/*
	IC Dialogs.h
	
*/

#pragma once

#ifndef __H_IC_Dialogs__
#define __H_IC_Dialogs__

enum { i_ok=1,i_cancel,i_discard };

#if defined(powerc)||defined(__powerc)
#pragma options align=mac68k
#endif
struct SavedWindowInfoStruct {
	GrafPtr oldport;
	GrafPtr thisport;
	short font;
	short size;
	Style face;
};
#if defined(powerc)||defined(__powerc)
#pragma options align=reset
#endif

typedef struct SavedWindowInfoStruct SavedWindowInfo;

#ifdef __cplusplus
extern "C" {
#endif

void SetItemText(DialogPtr dlg,short item,const StringPtr text);
void GetItemText(DialogPtr dlg,short item,StringPtr text);
StringPtr GetItemTextF(DialogPtr dlg,short item,StringPtr text);
pascal void OutlineDefault1(DialogPtr dp,short item);
void SetUpDefaultOutline(DialogPtr dp,short def_item,short user_item);
void FlashItem(DialogPtr dlg,short item);
void SetDItemRect(DialogPtr dp,short item,Rect* rr);
void GetDItemRect(DialogPtr dp,short item,Rect* rr);
void SetDItemKind(DialogPtr dp,short item,short k);
void GetDItemKind(DialogPtr dp,short item,short* k);
ControlHandle GetDControlHandle(DialogPtr dp,short item);
Handle GetDItemHandle(DialogPtr dp,short item);
void SetDItemHandle(DialogPtr dp,short item,Handle h);
Boolean GetDCtlEnable(DialogPtr dp,short item);
void SetDCtlEnable(DialogPtr dp,short item,Boolean on);
StringPtr GetDCtlTitle(DialogPtr dp,short item,StringPtr str);
void SetDCtlTitle(DialogPtr dp,short item,StringPtr s);
Boolean GetDCtlBoolean(DialogPtr dp,short item);
void SetDCtlBoolean(DialogPtr dlg,short item,Boolean value);
void ToggleDCtlBoolean(DialogPtr dp,short item);
short GetDCtlValue(DialogPtr dp,short item);
void SetDCtlValue(DialogPtr dp,short item,short value);
void DrawDItem(DialogPtr dp,short item);
MenuHandle GetPopupMHandle(DialogPtr dp,short item);
void SetPopUpMenuOnMouseDown(DialogPtr dlg,short item,StringPtr text);
void GetPopUpItemText(DialogPtr dlg,short item,StringPtr text);
void GetDAFont(short* font);
void SetWindowTitle(WindowPtr window,const StringPtr title);
short SelectedTextItem(DialogPtr dlg);
short CountDItems(DialogPtr dlg);
void ShiftTab(DialogPtr dlg);
void DrawTheFriggingGrowIcon(WindowPtr wind,Rect* bounds);
Boolean DoButtonKey(DialogPtr dlg,short item,EventRecord* er,short* result_item);
pascal Boolean OKModalFilter(DialogPtr dlg,EventRecord* er,short* item);
pascal Boolean CancelModalFilter(DialogPtr dlg,EventRecord* er,short* item);
pascal Boolean CancelDiscardModalFilter(DialogPtr dlg,EventRecord* er,short* item);
void EnterWindow(WindowPtr window,short font,short size,Style face,SavedWindowInfo* saved);
void ExitWindow(SavedWindowInfo* saved);
void DrawGrayRect(DialogPtr dlg,short item,StringPtr title);
Boolean Split(const StringPtr sub,const StringPtr s,StringPtr s1,StringPtr s2);
short StrToNum(const StringPtr s);

/*
	DisplayStyledString
	
	Displays a string with embedded style characteristics.
	
	Styled strings are in the form of:
	
		"\pFONT:SIZE:STYLE:JUST:TEXT"
	
	where font is the font number,
	size is the size in pixels,
	style is the correct Style, (h==hot, display URL's underlined in blue)
	just is the justification mode,
	and text is the rest of the string to display.
*/
void DisplayStyledString(DialogPtr dlg,short item,const StringPtr str);
void AddTrackItem(WindowPtr window,RgnHandle rgn,short i);
Boolean TrackItems(WindowPtr window,short i1,short i2,short i3);


#ifdef __cplusplus
}
#endif

#endif /* __H_IC_Dialogs__  */








