/*
	IC Movable Modal.h
	
*/

#pragma once

#ifndef __H_IC_Movable_Modal__
#define __H_IC_Movable_Modal__

#define kSystemMenuThreshold -16000 // menu IDs <= than this are used by the system
#define kMovableModalEventMask (mDownMask|mUpMask|keyDownMask|keyUpMask|autoKeyMask|updateMask|activMask|osMask)

#if defined(powerc) || defined (__powerc)
#pragma options align=mac68k
#endif
struct MenuEntryStruct {
	MenuHandle hMenu;
	short leftEdge;
};
#if defined(powerc) || defined (__powerc)
#pragma options align=reset
#endif

typedef struct MenuEntryStruct MenuEntry,* MenuEntryPtr;

#if defined(powerc) || defined (__powerc)
#pragma options align=mac68k
#endif
struct MenuListStruct {
	short offsetToLastMenu;
	short rightmostEdge;
	short unused;
	MenuEntry theMenus[1];
};
#if defined(powerc) || defined (__powerc)
#pragma options align=reset
#endif

typedef struct MenuListStruct MenuList,* MenuListPtr,** MenuListHandle;

#if defined(powerc) || defined (__powerc)
#pragma options align=mac68k
#endif
struct MenuBarStateStruct {
	long mbsBarEnable;
	long mbsEditEnable;
};
#if defined(powerc) || defined (__powerc)
#pragma options align=reset
#endif

typedef struct MenuBarStateStruct MenuBarState,* MenuBarStatePtr;

#ifdef __cplusplus
extern "C" {
#endif

pascal void CallBeeper(short soundNo,BeeperUPP beeperProc);
void DisableMenuBar(Ptr* saved_state,short hmnuID);
void ReEnableMenuBar(Ptr* saved_state);
Boolean DoMenuChoice(DialogPtr theDialog,EventRecord* er,short* itemHit,long menuChoice);
Boolean HandleMouseDown(DialogPtr theDialog,EventRecord* theEvent,short* itemHit);
void MovableModalDialog(ModalFilterUPP filterProc,short* itemHit);

#ifdef __cplusplus
}
#endif

#endif /* __H_IC_Movable_Modal__ */

