/*
	IC Text.h
	
	Header file for IC Text.c
	
*/

#pragma once

#ifndef __H_IC_Text__
#define __H_IC_Text__

#if defined(powerc) || defined (__powerc)
#pragma options align=mac68k
#endif
// Internal ItemData description
struct ItemDataStruct {
	DialogPtr window;
	short item;
	TEHandle te;
	FontInfo fi;
	short lineheight;
	Boolean active;
};
#if defined(powerc) || defined (__powerc)
#pragma options align=reset
#endif

typedef struct ItemDataStruct ItemData,* ItemDataPtr;

#ifdef __cplusplus
extern "C" {
#endif

OSErr TextCreate(Ptr* data,DialogPtr window,short item,short font,short size,Boolean locked);
void TextDestroy(Ptr* data);
void TextDraw(Ptr data);
void TextActivate(Ptr data,Boolean activate);
void TextClick(Ptr data,EventRecord* er);
void TextIdle(Ptr data);
void TextKey(Ptr data,EventRecord* er);
void TextSetSelect(Ptr data,long selStart,long selEnd);
void TextGetSelect(Ptr data,long* selStart,long* selEnd);
void TextGetSize(Ptr data,long* text_size);
void TextInsert(Ptr data,Handle h);
void TextGet(Ptr data,Handle h);
void TextMove(Ptr data,Rect* r);

void TextCut(Ptr data);
void TextCopy(Ptr data);
void TextPaste(Ptr data);
void TextClear(Ptr data);

#ifdef __cplusplus
}
#endif

#endif /* __H_IC_Text__ */


