/*
	IC Universals.c
	
	In the pascal code there was no need to use UPPs.  However, in
	C code (especially C code for 68k & ppc) we need to use UPPs.
	In order to keep from constantly building UPPs for every callback
	every time a window is opened, global UPPs are built for each
	function here and can be used anywhere else in the code.
	
*/

#include "IC Window Globals.h"

#include "IC Button What.h"
#include "IC Movable Modal.h"
#include "StandardGetFolder.h"
#include "IC StandardFile.h"
#include "IC Helper What.h"
#include "IC File Map What.h"
#include "IC Font Whats.h"
#include "IC Edit Pref AppleEvents.h"
#include "IC Dialogs.h"
#include "IC Misc Subs.h"
#include "IC Popup Whats.h"
#include "IC Text Whats.h"

DlgHookUPP gButtonHookUPP;		
ModalFilterUPP gAskServerFilter;		
UserItemUPP gDisplayFontProc;
ModalFilterUPP gMyModalFilter;	
AEEventHandlerUPP gHandleEditPrefAE;
DeviceLoopDrawingUPP gButtonDeviceLoopProc;
UserItemUPP gButtonUserItemUpdate;
FileFilterYDUPP gMyCustomGetDirectoryFileFilter;
DlgHookYDUPP gMyCustomGetDirectoryDlogHook;
UserItemUPP gDrawTextProc;
ModalFilterUPP gCancelModalFilter;
UserItemUPP gHelperUserItemUpdate;
ListDefUPP gHelperLDEF;
ModalFilterUPP gDoAddFilter;
ListKeyUPP gGetHelpEntryName;
ListKeyUPP gGetFileMapEntryName;
ModalFilterUPP gCancelDiscardModalFilter;
UserItemUPP gFileMapUserItemUpdate;
ListDefUPP gFileListLDEF;
ModalFilterUPP gOKModalFilter;
ModalFilterUPP gAddChangeFilter;
UserItemUPP gOutlineDefault1;

void InitUniversals(void){
	
	gButtonHookUPP=NewDlgHookProc(ButtonHook);
	gAskServerFilter=NewModalFilterProc(AskServerFilter);
	gDisplayFontProc=NewUserItemProc(DisplayFontProc);
	gMyModalFilter=NewModalFilterProc(MyModalFilter);
	gHandleEditPrefAE=NewAEEventHandlerProc(HandleEditPrefAE);
	gButtonDeviceLoopProc=NewDeviceLoopDrawingProc(ButtonDeviceLoopProc);
	gButtonUserItemUpdate=NewUserItemProc(ButtonUserItemUpdate);
	gMyCustomGetDirectoryFileFilter=NewFileFilterYDProc(MyCustomGetDirectoryFileFilter);
	gMyCustomGetDirectoryDlogHook=NewDlgHookYDProc(MyCustomGetDirectoryDlogHook);
	gDrawTextProc=NewUserItemProc(DrawTextProc);
	gCancelModalFilter=NewModalFilterProc(CancelModalFilter);
	gHelperUserItemUpdate=NewUserItemProc(HelperUserItemUpdate);
	gHelperLDEF=NewListDefProc(HelperLDEF);
	gDoAddFilter=NewModalFilterProc(DoAddFilter);
	gGetHelpEntryName=NewListKeyProc(GetHelpEntryName);
	gGetFileMapEntryName=NewListKeyProc(GetFileMapEntryName);
	gCancelDiscardModalFilter=NewModalFilterProc(CancelDiscardModalFilter);
	gFileMapUserItemUpdate=NewUserItemProc(FileMapUserItemUpdate);
	gFileListLDEF=NewListDefProc(MyLDEF);
	gOKModalFilter=NewModalFilterProc(OKModalFilter);
	gAddChangeFilter=NewModalFilterProc(AddChangeFilter);
	gOutlineDefault1=NewUserItemProc(OutlineDefault1);
	
}

