/*
	InternetConfig.c
	
	Main code routine for the Internet Config application.
	
*/

#include <SegLoad.h>
#include <AppleEvents.h>

#include "InternetConfig.h"

#include "RequiredEventSupport.h"
#include "IC Globals.h"
#include "IC Document.h"
#include "IC Events.h"
#include "IC Windows.h"
#include "IC Install.h"
#include "IC IconSuites.h"
#include "IC Misc Subs.h"
#include "IC Edit Pref AppleEvents.h"
#include "IC Initialization.h"

ApplicationUPP gOAppUPP;
DocumentUPP gODocUPP;
ApplicationUPP gQuitUPP;

/*
	HandleAppParams
	
*/
void HandleAppParams(void){
	AppFile ap_file;
	FSSpec fss;
	short msg,count;
	long junklong;
	
	if (Has_AppleEvents){
		gOAppUPP=NewApplicationProc(DoOpenApp);
		gODocUPP=NewDocumentProc(DoOpenDoc);
		gQuitUPP=NewApplicationProc(DoQuit);
		
		InitAppleEvents(gOAppUPP,gODocUPP,(DocumentUPP)0,gQuitUPP);
	} else {
#if defined(powerc)||defined(__powerc)
		
		// CountAppFiles is not allowed under PPC code
		DisplayError(acNewDocument,DoOpenApp());
#else
		CountAppFiles(&msg,&count);
		if (count<=0){
			DisplayError(acNewDocument,DoOpenApp());
		} else {
			GetAppFiles(1,&ap_file);
			ClrAppFiles(1);
			
			if (GetWDInfo(ap_file.vRefNum,&fss.vRefNum,&fss.parID,&junklong)==noErr){
				SetPString(fss.name,1,ap_file.fName);
				DisplayError(acOpenDocument,DoOpenDoc(&fss));
			}
		}
#endif
	}
}

void main(void){
	Handle mbar;
	OSErr err;
	
	Initialization();
	
	mbar=GetNewMBar(128);
	if (mbar==(Handle)0)
		ExitToShell();
	
	SetMenuBar(mbar);
	AppendResMenu(GetMenuHandle(M_Apple),'DRVR');
	DrawMenuBar();
	
	InitGlobals();
	InitMiscSubs();
	InitICIconSuites();
	
	err=InitICWindows();
	
	if (err==noErr)
		err=InitializeComponentInstallation();
	
	if (err==noErr)
		err=InitICDocument();
	
	if (err!=noErr){
		DisplayError(acStartApplication,err);
		ExitToShell();
	}
	
	HandleAppParams();
	SetupEditPrefAppleEvent();
	InitCursor();
	
	while (!quitnow)
		HandleEvents();
		
	TermICDocument();
}

