/*
	IC Document.h
	
*/

#pragma once

#ifndef __H_IC_Document__
#define __H_IC_Document__

extern ICInstance instance;
extern FSSpec current_file;
extern long current_seed;
extern FSSpec scratch_file; // open if name is not empty
extern Boolean new_document,dirty_document,locked_document;

#ifdef __cplusplus
extern "C" {
#endif

OSErr CopyFileSafe(FSSpec* source,FSSpec* dest);
ICInstance GetInstance(void);
Boolean IsDocOpen(void);
Boolean IsDocDirty(void);
Boolean IsDocNew(void);
void DirtyDocument(void);
Boolean IsDocLocked(void);
StringPtr GetDocumentName(StringPtr name);
Boolean PrefExists(const StringPtr key);
void SetPrefHandle(const StringPtr key,Handle h);
void SetPrefStr(const StringPtr key,const StringPtr data);
void CheckServerPref(const StringPtr key);
void AddDefaultPrefs(void);
OSErr CreateScratchFile(FSSpec* protofile);
OSErr DoCloseDoc(void);
OSErr DoCloseDocWindow(WindowPtr wp);
OSErr DoNewDoc(void);
void CurrentSeed(long* seed);
Boolean SameSeed(long seed1,long seed2);
OSErr DoOpenDoc(FSSpec* fss);
OSErr DoQuit(void);
OSErr DoSFOpen(void);
OSErr FindInternetPreferences(FSSpec* default_config);
OSErr EditPreference(StringPtr key,FSSpec* fs,Boolean usefss,Boolean usecurrent);
OSErr DoOpenInternetPreferences(void);
OSErr InternalDoSave(FSSpec* fss);
OSErr DoSave(void);
OSErr DoSaveAs(void);
OSErr DoOpenApp(void);
OSErr InitICDocument(void);
void TermICDocument(void);

#ifdef __cplusplus
}
#endif

#endif /* __H_IC_Document__ */

