/*
	IC Globals.h
	
	Header file for IC Globals.c
*/

#pragma once

#ifndef __H_IC_Globals__
#define __H_IC_Globals__

#include <Files.h>
#include <Events.h>

#include "IC Types.h"

// menu ids
#define M_Apple 128
#define M_File 129
#define M_Edit 130
#define M_Install 131
#define M_Windows 132

// edit menu choices
#define EM_Undo 1
#define EM_Cut 3
#define EM_Copy 4
#define EM_Paste 5
#define EM_Clear 6
#define EM_SelectAll 7

// file menu choices
#define FM_New 1
#define FM_Open 2
#define FM_OpenInternetPreferences 3
#define FM_Close 5
#define FM_Save 6
#define FM_SaveAs 7
#define FM_Quit 9

// install menu choices
#define IM_Install 1
#define IM_Save 2
#define IM_Remove 3

// other OS constants, probably declared somewhere now
#define kSysEnvironsVersion 1		
#define kOSEvent osEvt				// event used by MultiFinder
#define kSuspendResumeMessage 1		// high byte of suspend/resume event message
#define kResumeMask 1				// bit of mesage field *for* resume vs. suspend
#define kMouseMovedMessage 0xfa	// high byte of mouse-moved event message
#define kNoEvents 0					// no events mask

typedef enum {
	acDoThis,acInstallComponent,acOpenWindow,acNewDocument,acOpenDocument,acCloseWindow,acSave,
	acQuit,acStartApplication,acGetExample,acChooseApplication,acRemoveComponent,acSetDefaults,acSort
} ICAction;

// global variables set up by InitSystemGlobals

extern Boolean System7;
extern Boolean Has_AppleEvents;
extern Boolean Has_FindFolder;
extern Boolean Has_AliasMgr;
extern Boolean Has_NewStdFile;
extern Boolean Has_HelpMgr;
extern Boolean Has_ColorQD;
extern Boolean Has_Components;

extern short app_resfile;
extern FSSpec app_fs;
extern Boolean in_foreground;
extern Boolean quitnow;
extern VersRec app_version;

#ifdef __cplusplus
extern "C" {
#endif

Boolean CheckGestalt(OSType selector,short attr);
void DisplayError(ICAction action,OSErr err);
void InitGlobals(void);
Boolean InForeground(void);

#ifdef __cplusplus
}
#endif

#endif /* __H_IC_Globals__ */

