/*
	IC Misc Subs.h
	
*/

#pragma once

#ifndef __H_IC_Misc_Subs__
#define __H_IC_Misc_Subs__

#include <stdarg.h>

#include "IC Window Globals.h"

#ifndef topLeft
#define topLeft(r) (((Point*)&(r))[0])
#endif

#ifndef botRight
#define botRight(r) (((Point*)&(r))[1])
#endif

enum {
	nulChar=0,
	homeChar,
	enterChar=3,
	endChar,
	helpChar,
	backSpaceChar=8,
	tabChar,
	lfChar,
	pageUpChar,
	pageDownChar,
	crChar,
	escChar=0x1b,
	escKey=0x35,
	clearChar=0x1b,
	clearKey=0x47,
	leftArrowChar=0x1c,
	rightArrowChar,
	upArrowChar,
	downArrowChar,
	spaceChar=0x20,
	delChar=0x7f,
	bulletChar=0xa5,
	undoKey=0x7a,
	cutKey=0x78,
	copyKey=0x63,
	pasteKey=0x76
};

enum {
	kReturnKeyCode=36,
	kTabKeyCode=48,
	kSpaceKeyCode,
	kDeleteKeyCode=51,
	kEnterKeyCode,
	kCommandKeyCode=55,
	kShiftKeyCode,
	kCapsLockKeyCode,
	kOptionKeyCode,
	kClearKeyCode=71
};

enum {
	owner_id=-16096,
	machine_id=-16413
};

extern Str31 typed_chars;
extern long typed_time;
extern ListHandle typed_lh;

#ifdef __cplusplus
extern "C" {
#endif

OSErr PrepMem(void);

StringPtr VersionStr(long lver,StringPtr s);
StringPtr SetPString(StringPtr str,short ct,...);
StringPtr Delete(StringPtr str,short start,short end);
StringPtr NewPString(StringPtr str);
StringPtr Concat(StringPtr str,short ct,...);
StringPtr vConcat(StringPtr str,short ct,va_list v);
void InitMiscSubs(void);
StringPtr TPCopy(StringPtr to,StringPtr source,short start,short count);
short TPPos(StringPtr sub,StringPtr str);
void StringToOSType(StringPtr s,OSType* otype);
void OSTypeToString(OSType otype,StringPtr s);
void DrawIcon(short id,Rect* r,Boolean highlighted);
OSErr FSWriteQ(short refnum,long count,Ptr buf);
OSErr FSReadQ(short refnum,long count,Ptr buf);
short SelectedLine(ListHandle lh);
Boolean IsKeyDown(short keycode);
OSErr ICGetVolInfo(StringPtr name,short* vrn,short index,long* CrDate);
OSErr MyGetAPPL(OSType sig,FSSpec* fs);
OSErr ICFSpGetCatInfo(FSSpec* fs,short index,CInfoPBRec* pb);
OSErr ICFSpSetCatInfo(FSSpec* fs,CInfoPBRec* pb);
RgnHandle GetWindowContentRegion(WindowPtr wind);
RgnHandle GetWindowStructureRegion(WindowPtr wind);
Boolean TitleBarOnScreen(WindowPtr wp);
void GetWindowPortRect(WindowPtr wind,Rect* portRect);
void GetWindowRect(WindowPtr wind,Rect* r);
void CentreRect(Rect* inside_rect,Rect* res_rect);
void CentreAlert(short id);
StringPtr GetAString(StringPtr dest,short id,short index);
void Assert(Boolean b);
void SetItemEnable(MenuHandle mh,short item,Boolean enable);
Boolean DirtyKey(char ch);
OSErr IsVolumeWriteable(short vRefNum);
OSErr IsFileWriteable(FSSpec* fs);
OSErr HGetDirAccess(short vRefNum,long dirID,StringPtr name,long* ownerID,long* groupID,long* accessRights);
Boolean FileLocked(FSSpec* fss);
void LSetNoSelection(ListHandle list);
void LSetSingleSelection(ListHandle list,short v);
StringPtr LGetUniqueEntryName(ListHandle list,Cell* c,ListKeyUPP getentryname,StringPtr dest);
Boolean LGetFirstSelection(ListHandle list,Cell* c,ListKeyUPP getentryname);
Boolean LSelectFirstBefore(ListHandle list,const StringPtr s,ListKeyUPP getentryname);
Boolean LGetLastSelection(ListHandle list,Cell* c,ListKeyUPP getentryname);
Boolean LSelectFirstAfter(ListHandle list,const StringPtr s,ListKeyUPP getentryname,Boolean orequal);
void DoListKey(ListHandle list,EventRecord* er,ListKeyUPP getentryname);
StringPtr DecStr(long l,StringPtr s);
OSErr GetDirName(FSSpec* fs);
OSErr CopyFork(short srn,short drn,long len);
OSErr CopyFile(FSSpec* source,FSSpec* dest);
StringPtr GetName(short id1,short id2,StringPtr name);
StringPtr GetOwnerName(StringPtr name);
StringPtr GetMachineName(StringPtr name);

#ifdef __cplusplus
}
#endif

#endif /* __H_IC_Misc_Subs__ */


