/*
	IC Window Globals.h
	
	Header file for IC Window Globals.c
	
*/

#pragma once

#ifndef __H_IC_Window_Globals__
#define __H_IC_Window_Globals__

typedef enum {
	WT_None=0,WT_About,WT_Main,WT_Personal,WT_Email,WT_News,
	WT_FileTransfer,WT_OtherServices,WT_Font,WT_FileMapping,WT_Helper,
	WT_SocksServices
} WindowType;

extern short WT_Last;

enum {
	itemEnable=0
};

enum {
	whatNULL=1,whatTEXT,whatSPOP,whatFFSP,whatFPOP,whatFMAP,whatFBUT,
	whatHMAP,whatHBUT,whatBUTN,whatFSIZ,whatCBOX,whatLAST
};

#define item_max 10
#define whats_max whatLAST

#if defined(powerc) || defined (__powerc)
#pragma options align=mac68k
#endif
struct WhatStruct {
	Str31 key;
	OSType typ;
	long flags;
	Ptr data;
	Ptr spare_data;
	FSSpec fss;
	Boolean modified;
};
#if defined(powerc) || defined (__powerc)
#pragma options align=reset
#endif

typedef struct WhatStruct WhatRecord,* WhatRecordPtr;

#if defined(powerc) || defined (__powerc)
#pragma options align=mac68k
#endif
struct WindowInfoStruct {
	WindowPtr window;
	WhatRecordPtr items[item_max+1];
	Boolean window_key_needs_tabs;
	short selected_item;
	short id;
	Point position;
};
#if defined(powerc) || defined (__powerc)
#pragma options align=reset
#endif

typedef struct WindowInfoStruct WindowInfoRec,* WindowInfoPtr;

#if defined(powerc)||defined(__powerc)
#pragma options align=mac68k
#endif
struct WhatTemplateStruct {
	Str31 key;
	OSType typ;
	long flags;
};
#if defined(powerc)||defined(__powerc)
#pragma options align=reset
#endif

typedef struct WhatTemplateStruct WhatTemplateRecord,WhatTemplateArray[item_max+1],
	* WhatTemplateArrayPtr,** WhatTemplateArrayHandle;

typedef Point* PointArray;  // if WT_Last was a constant, we could use [WT_Last+1];

#include "IC Universals.h"

#if defined(powerc) || defined (__powerc)
#pragma options align=mac68k
#endif
struct WhatInfoStruct {
	OSType typ;
	WindowPlainUPP open;
	WindowEventUPP key;
	WindowEventUPP click;
	WindowBooleanUPP activate;
	WindowPlainUPP idle;
	WindowPlainUPP flush;
	WindowPlainUPP close;	// must be able to call close after successful *or* failed open
	WindowCursorUPP cursor;
	short cursorid;
};
#if defined(powerc) || defined (__powerc)
#pragma options align=reset
#endif

typedef struct WhatInfoStruct WhatInfoRec,* WhatInfoPtr;

#define wf_locked 31
#define wf_locked_mask 0x80000000

extern WindowInfoRec* WindowInfo;
extern WhatInfoRec WhatInfo[];

#ifdef __cplusplus
extern "C" {
#endif

short GetSelectedItem(WindowType wt);
WindowType GetWindowType(WindowPtr wp);

void ProcessAttributes(WindowType wt,short item,long attr);
Boolean IsLocked(WindowType wt,short item);
void LockedAlert(WindowType wt,short item);

void InitICWindowGlobals(void);

#ifdef __cplusplus
}
#endif

#endif /* __H_IC_Window_Globals__ */






