/*
	IC Windows.h
	
*/

#pragma once

#ifndef __H_IC_Windows__
#define __H_IC_Windows__

#include "IC Window Globals.h"

// This value is different than the original IC App's value, I didn't want to use those values
// For those that haven't figured it out, it should be the app's creator
#define OurWindowPositionKey "\p43494341WindowPositions"

#ifdef __cplusplus
extern "C" {
#endif

void InvalidateAbout(void);
OSErr CallWhatOpen(WindowType wt,short item,WindowPlainUPP open);
OSErr CallWhatClose(WindowType wt,short item,WindowPlainUPP close);
OSErr CallWhatFlush(WindowType wt,short item,WindowPlainUPP flush);
OSErr CallWhatClick(WindowType wt,short item,EventRecord* er,WindowEventUPP click);
OSErr CallWhatKey(WindowType wt,short item,EventRecord* er,WindowEventUPP key);
OSErr CallWhatActivate(WindowType wt,short item,Boolean activate,WindowBooleanUPP actproc);
OSErr CallWhatIdle(WindowType wt,short item,WindowPlainUPP idleproc);
OSErr CallWhatCursor(WindowType wt,short item,Point pt,short curs,WindowCursorUPP cursproc);
short TypeToWhat(OSType typ);
OSType GetWhatType(WindowType wt,short item);
WindowPtr GetWindowPtr(WindowType wt);
Boolean OurWindow(WindowPtr wp);
OSErr WhatIdleText(WindowType wt,short item,short* cursor);
void DoWindowIdle(WindowPtr window);
void WindowDoKey(WindowPtr window,EventRecord* er);
void WindowActivateDeactivate(WindowPtr window,Boolean activate);
ICError LaunchSomeSillyURL(StringPtr url);
void DoAboutClick(WindowPtr window,short item);
void WindowItemWhere(WindowPtr window,EventRecord* er,short item);
Boolean WindowEarlyHandleEvent(WindowPtr window,EventRecord* er);
void WindowTab(WindowPtr window,Boolean shift);
Boolean WindowEarlyHandleKey(WindowPtr window,EventRecord* er);
OSErr FlushWindowType(WindowPtr wp,WindowType wt);
OSErr DisposeWindowType(WindowPtr wp,WindowType wt);
OSErr CloseWindowType(WindowPtr wp,WindowType wt);
Boolean WindowsEarlyHandleEvent(EventRecord* er);
Boolean WindowsEarlyHandleKey(EventRecord* er);
void WindowsDoKey(EventRecord* er);
void WindowsIdle(void);
void WindowsSetTitle(WindowType wt,const StringPtr title);
void WindowsAdjustMenus(void);
void WindowsDoEditMenu(short item);
OSErr ParseWhat(WindowType wt);
short GetWindowID(WindowType wt);
Boolean IsPrefix(StringPtr s,const StringPtr key);
OSErr EditCurrentPreference(StringPtr key);
OSErr PrepWindow(WindowType wt,short id,WindowPtr wp);
OSErr NewICWindow(WindowType wt);
OSErr WindowsOpen(WindowType wt);
OSErr WindowsClose(WindowPtr wp);
void WindowsResetPositions(void);
void WindowsRestorePositions(void);
void WindowsSavePositions(void);
OSErr WindowsFlushAll(void);
OSErr WindowsCloseAll(void);
void W(short what,OSType xtyp,WindowPlainUPP xopen,WindowEventUPP xkey,WindowEventUPP xclick,
		WindowPlainUPP xidle,WindowPlainUPP xflush,WindowPlainUPP xclose,WindowBooleanUPP xactivate,
		WindowCursorUPP xcursor,short xcursorid);
void InitWhats(void);
pascal void AboutBoxUpdate(DialogPtr dlg,short item);
OSErr InitICWindows(void);

#ifdef __cplusplus
}
#endif

#endif /* __H_IC_Windows__ */

