/*
	IC Specific Override.c
	
	This is a C port of the ICSpecificOverride.p file.
	
	History:
		11/17/95 dhn - Started port.
*/

/*
	Original comment:
	
	Internet Config Specific Overide Component
	
	Routine names have an ICSO prefix for Internet Config Specific Override.
	
	To create an IC override component you need to make a copy of this
	file and fill in the blanks. This is an N stage process:
	
	1. Make a copy of this file.
	2. Change kOurComponentManufacturer to your manufacturer code.
	3. Add any shared globals to the sharedGlobals record.
	4. If you have shared globals then init them in ICSOInitShared.
	5. If the shared globals need cleaning up then clean them ICSOCleanShared.
	6. Add any instance specific globals to globalsRecord.
	7. If you have globals then init them in ICSOInitGlobals.
	8. If the globals need cleaning up then clean them ICSOCleanGlobals.
	9. If you want to add a completely new routine or remove support for one of the built in routines then modify
		ICSOCanDo accordingly.
	10. Modify ICSOWhatToOverride to return the correct ProcPtr for each routine that you override or add.
	11. Write each routine. If you want the component to continue calling through to the captured component for
			this routine then have your routine return delegateThisCallErr.
	12. Smirk at the wonders of Component Manager.
	13. Looking inside ICGenericOverride and frown at the wonders of Component Manager.
	
	Share and Enjoy.
	
	Quinn
	12 Feb 1995
*/

#include <Components.h>

#include "IC Specific Override.h"

#include "IC Component API.h"
#include "IC Component Selectors.h"

pascal ComponentResult ICSOInitShared(GlobalsHandle globals){
	
	return noErr;
}

pascal ComponentResult ICSOCleanShared(GlobalsHandle globals){
	
	return noErr;
}

pascal ComponentResult ICSOInitGlobals(GlobalsHandle globals){
	
	return noErr;
}

pascal ComponentResult ICSOCleanGlobals(GlobalsHandle globals){
	
	return noErr;
}

pascal ComponentResult ICSOCanDo(GlobalsHandle globals,short selector){
	
	return delegateThisCallErr;
}

pascal ComponentFunctionUPP ICSOWhatToOverride(GlobalsHandle globals,short selector){
	ComponentFunctionUPP proc=(ComponentFunctionUPP)0;
	
	return proc;
}
