/*
	IC Generic Override.h
	
	Header file for IC Generic Override.c
	
*/

#pragma once

#ifndef __H_IC_Generic_Override__
#define __H_IC_Generic_Override__

#include "IC Specific Override.h"

/*
	The following enumeration creates many procinfo values for each of the
	interface routines called through the component manager.
*/
enum {
	uppICGOGlobalsProcInfo=kPascalStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(ComponentResult)))
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(GlobalsHandle))),
	uppICGOShortProcInfo=kPascalStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(ComponentResult)))
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(GlobalsHandle)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(short))),
	uppICGOInstanceProcInfo=kPascalStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(ICError)))
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(GlobalsHandle)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(ComponentInstance)))
};

#undef BuildNewProc
#define BuildNewProc(routine,procinfo) \
	(ComponentFunctionUPP)NewRoutineDescriptor((ProcPtr)(routine),(procinfo),GetCurrentISA())

#ifdef __cplusplus
extern "C" }{
#endif

// local prototypes
pascal ComponentResult ICGOFixCloneRefCon(ComponentInstance self);
pascal ComponentResult ICGOGetSharedGlobals(GlobalsHandle globals);
pascal ComponentResult ICGORegister(GlobalsHandle globals);
pascal ComponentResult ICGOUnregister(GlobalsHandle globals);
pascal ComponentResult ICGOCanDo(GlobalsHandle globals,short selector);
pascal Component ICGOFindDelegate(Component after);
pascal ComponentResult ICGOOpen(GlobalsHandle globals,ComponentInstance self);
pascal ComponentResult ICGOClose(GlobalsHandle globals,ComponentInstance self);
pascal ComponentResult ICGOTarget(GlobalsHandle globals,ComponentInstance new_target);
pascal ComponentResult main(ComponentParameters* params,Handle storage);

#ifdef __cplusplus
}
#endif

#endif /* __H_IC_Generic_Override__ */


